package org.faktorips.tutorial.model.hausrat;

import org.faktorips.runtime.InMemoryRuntimeRepository;

/**
 * Implementierung von HausratGrunddeckungstypBuilder. Ein HausratGrunddeckungstypBuilder stellt
 * alle Funktionen bereit, die für das Erstellen einer Instanz der Klasse HausratGrunddeckungstyp
 * notwendig sind. Beachte, dass diese Klasse für Tests gedacht ist. Alle Produktbausteintypen
 * müssen hierfür in einem {@link InMemoryRuntimeRepository} liegen, da die Instanzen in Runtime
 * Repository nicht verändert werden können.
 *
 * @generated
 */
public class HausratGrunddeckungstypBuilder {
    /**
     * @generated
     */
    private final InMemoryRuntimeRepository runtimeRepository;

    /**
     * @generated
     */
    private final HausratGrunddeckungstyp hausratGrunddeckungstyp;

    /**
     * Erzeugt eine neue Instanz von HausratGrunddeckungstypBuilder mit einem Produkt. Das Produkt
     * muss im angegebenen {@link InMemoryRuntimeRepository} liegen, das selbst nicht null sein
     * darf.
     *
     * @generated
     */
    protected HausratGrunddeckungstypBuilder(HausratGrunddeckungstyp product,
            InMemoryRuntimeRepository runtimeRepository) {
        if (product == null || runtimeRepository == null) {
            throw new RuntimeException("Das Produkt und Repository dürfen nicht null sein!");
        } else {
            runtimeRepository.getExistingProductComponent(product.getId());

            this.runtimeRepository = runtimeRepository;
            this.hausratGrunddeckungstyp = product;
        }
    }

    /**
     * Setzt den Wert der Eigenschaft bezeichnung.
     *
     * @generated
     */
    public HausratGrunddeckungstypBuilder bezeichnung(String bezeichnung) {
        hausratGrunddeckungstyp.setBezeichnung(bezeichnung);
        return this;
    }

    /**
     * @return {@link InMemoryRuntimeRepository}, welches gespeichert wurde.
     *
     * @generated
     */
    public InMemoryRuntimeRepository getRepository() {
        return this.runtimeRepository;
    }

    /**
     * @return Instanz von HausratGrunddeckungstyp, die gebaut wurde
     *
     * @generated
     */
    public HausratGrunddeckungstyp getResult() {
        return hausratGrunddeckungstyp;
    }

    /**
     * Interne Methode
     *
     * @generated
     */
    public static Class<?> getProductClass() {
        return HausratGrunddeckungstyp.class;
    }

    /**
     * Erzeugt ein neues HausratGrunddeckungstypBuilder mit HausratGrunddeckungstyp und einem
     * Runtime Repository.
     *
     * @generated
     */
    public static HausratGrunddeckungstypBuilder from(HausratGrunddeckungstyp product,
            InMemoryRuntimeRepository runtimeRepository) {
        return new HausratGrunddeckungstypBuilder(product, runtimeRepository);
    }

}
