package org.faktorips.tutorial.model.hausrat;

import java.util.Map;

import org.faktorips.runtime.FormulaExecutionException;
import org.faktorips.runtime.IRuntimeRepository;
import org.faktorips.runtime.IllegalRepositoryModificationException;
import org.faktorips.runtime.InMemoryRuntimeRepository;
import org.faktorips.runtime.internal.DateTime;
import org.faktorips.runtime.internal.ProductComponent;
import org.faktorips.runtime.internal.ValueToXmlHelper;
import org.faktorips.runtime.model.annotation.IpsAttribute;
import org.faktorips.runtime.model.annotation.IpsAttributeSetter;
import org.faktorips.runtime.model.annotation.IpsAttributes;
import org.faktorips.runtime.model.annotation.IpsConfigures;
import org.faktorips.runtime.model.annotation.IpsDocumented;
import org.faktorips.runtime.model.annotation.IpsProductCmptType;
import org.faktorips.runtime.model.type.AttributeKind;
import org.faktorips.runtime.model.type.ValueSetKind;
import org.faktorips.values.Decimal;
import org.faktorips.values.Money;
import org.w3c.dom.Element;

/**
 * Implementierung von HausratZusatzdeckungstyp.
 *
 * @generated
 */
@IpsProductCmptType(name = "hausrat.HausratZusatzdeckungstyp")
@IpsAttributes({ "bezeichnung", "versSummenFaktor", "maximaleVersSumme" })
@IpsConfigures(HausratZusatzdeckung.class)
@IpsDocumented(bundleName = "org.faktorips.tutorial.model.model-label-and-descriptions", defaultLocale = "de")
public class HausratZusatzdeckungstyp extends ProductComponent {

    /**
     * Diese Konstante enthält den Namen der Eigenschaft versSummenFaktor.
     *
     * @generated
     */
    public static final String PROPERTY_VERSSUMMENFAKTOR = "versSummenFaktor";
    /**
     * Diese Konstante enthält den Namen der Eigenschaft maximaleVersSumme.
     *
     * @generated
     */
    public static final String PROPERTY_MAXIMALEVERSSUMME = "maximaleVersSumme";
    /**
     * Diese Konstante enthält den Namen der Eigenschaft bezeichnung.
     *
     * @generated
     */
    public static final String PROPERTY_BEZEICHNUNG = "bezeichnung";
    /**
     * Membervariable für die Produkteigenschaft VersSummenFaktor.
     *
     * @generated
     */
    private Decimal versSummenFaktor;
    /**
     * Membervariable für die Produkteigenschaft MaximaleVersSumme.
     *
     * @generated
     */
    private Money maximaleVersSumme;

    /**
     * Membervariable für die Produkteigenschaft Bezeichnung.
     *
     * @generated
     */
    private String bezeichnung;

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckungstyp.
     *
     * @generated
     */
    public HausratZusatzdeckungstyp(IRuntimeRepository repository, String id, String kindId, String versionId) {
        super(repository, id, kindId, versionId);
    }

    /**
     * {@inheritDoc}
     *
     * @generated
     */
    @Override
    public boolean isChangingOverTime() {
        return false;
    }

    /**
     * Gibt den Wert der Eigenschaft versSummenFaktor zurück.
     *
     * @generated
     */
    @IpsAttribute(name = "versSummenFaktor", kind = AttributeKind.CONSTANT, valueSetKind = ValueSetKind.AllValues)
    public Decimal getVersSummenFaktor() {
        return versSummenFaktor;
    }

    /**
     * Setzt den Wert der Eigenschaft versSummenFaktor.
     *
     * @generated
     */
    @IpsAttributeSetter("versSummenFaktor")
    public void setVersSummenFaktor(Decimal newValue) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        setVersSummenFaktorInternal(newValue);
    }

    /**
     * Setzt den Wert der Eigenschaft versSummenFaktor.
     *
     * @generated
     */
    protected final void setVersSummenFaktorInternal(Decimal newValue) {
        this.versSummenFaktor = newValue;
    }

    /**
     * Gibt den Wert der Eigenschaft maximaleVersSumme zurück.
     *
     * @generated
     */
    @IpsAttribute(name = "maximaleVersSumme", kind = AttributeKind.CONSTANT, valueSetKind = ValueSetKind.AllValues)
    public Money getMaximaleVersSumme() {
        return maximaleVersSumme;
    }

    /**
     * Setzt den Wert der Eigenschaft maximaleVersSumme.
     *
     * @generated
     */
    @IpsAttributeSetter("maximaleVersSumme")
    public void setMaximaleVersSumme(Money newValue) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        setMaximaleVersSummeInternal(newValue);
    }

    /**
     * Setzt den Wert der Eigenschaft maximaleVersSumme.
     *
     * @generated
     */
    protected final void setMaximaleVersSummeInternal(Money newValue) {
        this.maximaleVersSumme = newValue;
    }

    /**
     * @generated
     */
    public Money berechneJahresbasisbeitrag(HausratVertrag vertrag, HausratZusatzdeckung deckung)
            throws FormulaExecutionException {
        return (Money)getFormulaEvaluator().evaluate("berechneJahresbasisbeitrag", vertrag, deckung);
    }

    /**
     * Gibt den Wert der Eigenschaft bezeichnung zurück.
     *
     * @generated
     */
    @IpsAttribute(name = "bezeichnung", kind = AttributeKind.CONSTANT, valueSetKind = ValueSetKind.AllValues)
    public String getBezeichnung() {
        return bezeichnung;
    }

    /**
     * Setzt den Wert der Eigenschaft bezeichnung.
     *
     * @generated
     */
    @IpsAttributeSetter("bezeichnung")
    public void setBezeichnung(String newValue) {
        if (getRepository() != null && !getRepository().isModifiable()) {
            throw new IllegalRepositoryModificationException();
        }
        setBezeichnungInternal(newValue);
    }

    /**
     * Setzt den Wert der Eigenschaft bezeichnung.
     *
     * @generated
     */
    protected final void setBezeichnungInternal(String newValue) {
        this.bezeichnung = newValue;
    }

    /**
     * {@inheritDoc}
     *
     * @generated
     */
    @Override
    protected void doInitPropertiesFromXml(Map<String, Element> configMap) {
        super.doInitPropertiesFromXml(configMap);
        doInitBezeichnung(configMap);
        doInitVersSummenFaktor(configMap);
        doInitMaximaleVersSumme(configMap);
    }

    /**
     * @generated
     */
    private void doInitVersSummenFaktor(Map<String, Element> configMap) {
        Element configElement = configMap.get(PROPERTY_VERSSUMMENFAKTOR);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            this.versSummenFaktor = Decimal.valueOf(value);
        }
    }

    /**
     * @generated
     */
    private void doInitMaximaleVersSumme(Map<String, Element> configMap) {
        Element configElement = configMap.get(PROPERTY_MAXIMALEVERSSUMME);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            this.maximaleVersSumme = Money.valueOf(value);
        }
    }

    /**
     * @generated
     */
    private void doInitBezeichnung(Map<String, Element> configMap) {
        Element configElement = configMap.get(PROPERTY_BEZEICHNUNG);
        if (configElement != null) {
            String value = ValueToXmlHelper.getValueFromElement(configElement, ValueToXmlHelper.XML_TAG_VALUE);
            this.bezeichnung = value;
        }
    }

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckung, die durch diesen Produktbaustein
     * konfiguriert wird.
     *
     * @generated
     */
    public HausratZusatzdeckung createHausratZusatzdeckung() {
        HausratZusatzdeckung policy = new HausratZusatzdeckung(this);
        policy.initialize();
        return policy;
    }

    /**
     * {@inheritDoc}
     *
     * @generated
     */
    @Override
    public HausratZusatzdeckung createPolicyComponent() {
        return createHausratZusatzdeckung();
    }

    /**
     * Erzeugt ein neues HausratZusatzdeckungstypBuilder um dieses Produkt zu bearbeiten.
     *
     * @generated
     */
    public HausratZusatzdeckungstypBuilder modify() {
        return HausratZusatzdeckungstypBuilder.from(this, (InMemoryRuntimeRepository)this.getRepository());
    }

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckungstyp mit einem
     * {@link InMemoryRuntimeRepository}, ID, kindID und versionID. Das Wirksamkeitsdatum der neuen
     * Instanz wird auf 1900/1/1 gesetzt.
     *
     * @generated
     */
    public static HausratZusatzdeckungstypBuilder builder(InMemoryRuntimeRepository runtimeRepository,
            String id,
            String kindId,
            String versionId) {
        HausratZusatzdeckungstyp product = new HausratZusatzdeckungstyp(runtimeRepository, id, kindId, versionId);
        product.setValidFrom(new DateTime(1900, 1, 1));
        runtimeRepository.putProductComponent(product);

        return new HausratZusatzdeckungstypBuilder(product, runtimeRepository);
    }

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckungstyp mit einem
     * {@link InMemoryRuntimeRepository}, ID, kindID und versionID.
     *
     * @generated
     */
    public static HausratZusatzdeckungstypBuilder builder(InMemoryRuntimeRepository runtimeRepository,
            String id,
            String kindId,
            String versionId,
            DateTime validFrom) {
        HausratZusatzdeckungstyp product = new HausratZusatzdeckungstyp(runtimeRepository, id, kindId, versionId);
        product.setValidFrom(validFrom);
        runtimeRepository.putProductComponent(product);

        return new HausratZusatzdeckungstypBuilder(product, runtimeRepository);
    }

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckungstyp mit dem ID von einem existierenden
     * Produktbaustein.
     *
     * @generated
     */
    public static HausratZusatzdeckungstypBuilder builder(InMemoryRuntimeRepository runtimeRepository,
            String prodCmptId) {
        HausratZusatzdeckungstyp product = (HausratZusatzdeckungstyp)runtimeRepository.getProductComponent(prodCmptId);

        if (product == null) {
            throw new RuntimeException("Keinen Produktbaustein mit der gegebenden ID gefunden!");
        } else {
            return HausratZusatzdeckungstypBuilder.from(product, runtimeRepository);
        }
    }
}
