package org.faktorips.tutorial.model.hausrat;

import org.faktorips.runtime.InMemoryRuntimeRepository;
import org.faktorips.values.Decimal;
import org.faktorips.values.Money;

/**
 * Implementierung von HausratZusatzdeckungstypBuilder. Ein HausratZusatzdeckungstypBuilder stellt
 * alle Funktionen bereit, die für das Erstellen einer Instanz der Klasse HausratZusatzdeckungstyp
 * notwendig sind. Beachte, dass diese Klasse für Tests gedacht ist. Alle Produktbausteintypen
 * müssen hierfür in einem {@link InMemoryRuntimeRepository} liegen, da die Instanzen in Runtime
 * Repository nicht verändert werden können.
 *
 * @generated
 */
public class HausratZusatzdeckungstypBuilder {
    /**
     * @generated
     */
    private final InMemoryRuntimeRepository runtimeRepository;

    /**
     * @generated
     */
    private final HausratZusatzdeckungstyp hausratZusatzdeckungstyp;

    /**
     * Erzeugt eine neue Instanz von HausratZusatzdeckungstypBuilder mit einem Produkt. Das Produkt
     * muss im angegebenen {@link InMemoryRuntimeRepository} liegen, das selbst nicht null sein
     * darf.
     *
     * @generated
     */
    protected HausratZusatzdeckungstypBuilder(HausratZusatzdeckungstyp product,
            InMemoryRuntimeRepository runtimeRepository) {
        if (product == null || runtimeRepository == null) {
            throw new RuntimeException("Das Produkt und Repository dürfen nicht null sein!");
        } else {
            runtimeRepository.getExistingProductComponent(product.getId());

            this.runtimeRepository = runtimeRepository;
            this.hausratZusatzdeckungstyp = product;
        }
    }

    /**
     * Setzt den Wert der Eigenschaft versSummenFaktor.
     *
     * @generated
     */
    public HausratZusatzdeckungstypBuilder versSummenFaktor(Decimal versSummenFaktor) {
        hausratZusatzdeckungstyp.setVersSummenFaktor(versSummenFaktor);
        return this;
    }

    /**
     * Setzt den Wert der Eigenschaft maximaleVersSumme.
     *
     * @generated
     */
    public HausratZusatzdeckungstypBuilder maximaleVersSumme(Money maximaleVersSumme) {
        hausratZusatzdeckungstyp.setMaximaleVersSumme(maximaleVersSumme);
        return this;
    }

    /**
     * Setzt den Wert der Eigenschaft bezeichnung.
     *
     * @generated
     */
    public HausratZusatzdeckungstypBuilder bezeichnung(String bezeichnung) {
        hausratZusatzdeckungstyp.setBezeichnung(bezeichnung);
        return this;
    }

    /**
     * @return {@link InMemoryRuntimeRepository}, welches gespeichert wurde.
     *
     * @generated
     */
    public InMemoryRuntimeRepository getRepository() {
        return this.runtimeRepository;
    }

    /**
     * @return Instanz von HausratZusatzdeckungstyp, die gebaut wurde
     *
     * @generated
     */
    public HausratZusatzdeckungstyp getResult() {
        return hausratZusatzdeckungstyp;
    }

    /**
     * Interne Methode
     *
     * @generated
     */
    public static Class<?> getProductClass() {
        return HausratZusatzdeckungstyp.class;
    }

    /**
     * Erzeugt ein neues HausratZusatzdeckungstypBuilder mit HausratZusatzdeckungstyp und einem
     * Runtime Repository.
     *
     * @generated
     */
    public static HausratZusatzdeckungstypBuilder from(HausratZusatzdeckungstyp product,
            InMemoryRuntimeRepository runtimeRepository) {
        return new HausratZusatzdeckungstypBuilder(product, runtimeRepository);
    }

}
