package org.faktorips.tutorial.model.test;

import javax.xml.parsers.ParserConfigurationException;

import org.faktorips.runtime.DefaultObjectReferenceStore;
import org.faktorips.runtime.DefaultReferenceResolver;
import org.faktorips.runtime.IObjectReferenceStore;
import org.faktorips.runtime.internal.XmlUtil;
import org.faktorips.runtime.test.IpsTestCase2;
import org.faktorips.runtime.test.IpsTestResult;
import org.faktorips.tutorial.model.hausrat.HausratVertrag;
import org.w3c.dom.Element;

/**
 * Instanzen dieser Klasse sind fachliche Testfaelle. Das Testen der fachlichen Logik findet in der
 * Methode executeAsserts() statt. Die Daten fuer die Testfaelle werden von FaktorIPS-Testfaellen
 * geliefert, die auf dem Testfalltyp basieren, auf dessen Basis auch diese Klasse generiert wird.
 *
 * @generated
 */
public class BeitragsberechnungHausratTest extends IpsTestCase2 {

    /**
     * @generated
     */
    private HausratVertrag inputHausratVertrag;
    /**
     * @generated
     */
    private HausratVertrag erwartetHausratVertrag;

    /**
     * Erzeugt eine neue Instanz des Testfalls.
     * 
     * @restrainedmodifiable
     */
    public BeitragsberechnungHausratTest(String qualifiedName) throws ParserConfigurationException {
        super(qualifiedName);
        // begin-user-code
        // end-user-code
    }

    /**
     * Fuehrt die zu testende Geschaeftslogik aus.
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void executeBusinessLogic() {
        // begin-user-code
        inputHausratVertrag.berechneBeitrag();
        // end-user-code
    }

    /**
     * Fuehrt die Pruefungen (Asserts) aus, d.h. vergleicht die erwarteten Werten mit den
     * tatsaechlichen Ergebnissen.
     * <p>
     * Dies geschieht analog zu JUnit mit Aufrufen von assert(..) Methoden. Zum Beispiel
     * assertEquals(erwartetVertrag.getBeitrag(), inputVertrag.getBeitrag(), result);
     * 
     * Um das getestete Objekt bzw. das Attribut genauer zu beschreiben, kann zusaetzlich der Name
     * des getesteten Objektes und der Attributname uebergeben werden, bei der Ausfuehrung als
     * Faktor-Ips Testfall, wird dann im Fehlerfall das entsprechende Attribut-Feld im
     * Testfalleditor als rot gekennzeichnet. Der Name des Objektes bzw. der Name des Attributes,
     * muss gleich dem im Testfalltyp definierten Namen sein. Es muss immer der komplette Pfad zu
     * dem Testobjekt angegeben werden, wobei die einzelnen Testobjekte auf den unterschiedlichen
     * Ebenen (Root/Parent/Child) durch "." getrennt werden muessen. Wenn im Testfall mehrere
     * Instanzen des gleiche Testobjektes vorhanden sind, muss ein Index an den Namen (getrennt
     * durch "#") angefuegt werden. Beispiel: assertEquals(erwartetVertrag.getBeitrag(),
     * inputVertrag.getBeitrag(), result, "Police#0.Vertrag#0", "beitrag");
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void executeAsserts(IpsTestResult result) {
        // begin-user-code
        assertEquals(erwartetHausratVertrag.getNettobeitragZw(),
                inputHausratVertrag.getNettobeitragZw(),
                result,
                "HausratVertrag",
                "nettobeitragZw");
        // end-user-code
    }

    /**
     * Initialisiert die Eingabewerte aus dem XML.
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void initInputFromXml(Element element) {
        // begin-user-code
        // end-user-code
        IObjectReferenceStore objectReferenceStore = new DefaultObjectReferenceStore();
        Element childElement = null;
        childElement = XmlUtil.getFirstElement(element, "HausratVertrag");
        if (childElement != null) {
            try {
                String className = childElement.getAttribute("class");
                inputHausratVertrag = (HausratVertrag)Class
                        .forName(className, true, HausratVertrag.class.getClassLoader()).getConstructor().newInstance();
                inputHausratVertrag.initFromXml(childElement, true, getRepository(), objectReferenceStore);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        try {
            new DefaultReferenceResolver().resolve(objectReferenceStore);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Initialisiert die erwarteten Werte aus dem XML.
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void initExpectedResultFromXml(Element element) {
        // begin-user-code
        // end-user-code
        IObjectReferenceStore objectReferenceStore = new DefaultObjectReferenceStore();
        Element childElement = null;
        childElement = XmlUtil.getFirstElement(element, "HausratVertrag");
        if (childElement != null) {
            try {
                String className = childElement.getAttribute("class");
                erwartetHausratVertrag = (HausratVertrag)Class
                        .forName(className, true, HausratVertrag.class.getClassLoader()).getConstructor().newInstance();
                erwartetHausratVertrag.initFromXml(childElement, true, getRepository(), objectReferenceStore);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        try {
            new DefaultReferenceResolver().resolve(objectReferenceStore);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
